unit LogHandler;

interface

uses Windows, SysUtils, Classes, SyncObjs;

const
  MESSAGELOG                = 0;
  SOCKET_MESSAGELOG         = 1;
  CUSTOM_MESSAGELOG         = 2;
  SEND_BUF_LOG              = 3;

  procedure AddToLog(const LogString: string);
  procedure AddCustomLog(p1, p2: dword; MsgType: integer);
  procedure ErrorCheck;

implementation

uses UnitMain;

var
  LogCS: TCriticalSection;

procedure AddToLog(const LogString: string);
var
   FormatLogString, LogFileLogString: string;
   LogFile: TFileStream;
begin
    LogCS.Enter;
    try
      FormatLogString := '['+TimeToStr(Now)+'] ' + LogString;
      LogFileLogString:= FormatLogString + #$d#$a;
      if not(FileExists(LogFileName)) then
        LogFile:= TFileStream.Create(LogFileName, fmCreate)
      else begin
        LogFile:= TFileStream.Create(LogFileName, fmOpenReadWrite);
        LogFile.Seek(0, soFromEnd);
      end;
      LogFile.Write(LogFileLogString[1], length(LogFileLogString));
      LogFile.Free;

      if not(Form1DestroyPending) then Form1.AddShowToLog(FormatLogString);
    finally LogCS.Leave;
    end;
end;

procedure AddCustomLog(p1, p2: dword; MsgType: integer);
var
   pErrorString: PChar;
   i: integer;
   temp: string;
   tempptr: pointer;
const
   MSG_LEN: dword = 200;
begin
    case MsgType of
      MESSAGELOG        : AddToLog(PAnsiChar(pointer(p1)));
      SOCKET_MESSAGELOG : begin
        GetMem(pErrorString,MSG_LEN);
        FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, p1, 0, pErrorString, MSG_LEN, nil);
        AddToLog('error ' + IntToStr(p1) + ' : ' + strpas(pErrorString));
        FreeMem(pErrorString);
      end;
      {CUSTOM_MESSAGELOG : begin
      end;}
      SEND_BUF_LOG      : begin
        temp:= 'Sent len = ' + IntToStr(p2) + ' : ';
        tempptr:= pointer(p1);
        for i:= 0 to p2 - 1 do begin
          temp:= temp + IntToHex(byte(tempptr^),2) + ' ';
          inc(integer(tempptr));
        end;
        AddToLog(temp);
        //FreeMem(pointer(p1));
      end;
    end;
end;

procedure ErrorCheck;
begin
     AddCustomLog(GetLastError, 0, SOCKET_MESSAGELOG);
end;

{procedure TForm1.WMWriteLog(var Msg: TMessage);
begin
     case Msg.WParam of
          MSG_FREE_CLIENT_CONTEXT              : AddShowToLog('Free client context, socket='+IntToStr(Msg.LParam));
          MSG_ERROR_SEND_NIL_CONTEXT           : AddShowToLog('Attempt to send through nil ClientContext, socket='+IntToStr(Msg.LParam));
          MSG_ERROR_CONNECTED_SEND_NIL_CONTEXT : AddShowToLog('Attempt to send through nil ClientContext, connected socket');
     end;
end;}

initialization

    LogCS:=TCriticalSection.Create;

finalization

    LogCS.Free;

end.
